/*

*/

package tokenizer;

/**
   An instance of this class represents one token.
   <p>
   In these simple examples a {@code Token} is always
   a single character.
   <p>
   Each {@code Token} remembers its position in the
   original {@link String} from the language being
   parsed.
*/
public class Token
{
   public final String lexeme;   // the character of this token
   public final int    position; // position of this token

   /**
      @param lexeme    the {@link String} token itself
      @param position  the token's position in the {@link String}
   */
   public Token(final String lexeme, final int position)
   {
      this.lexeme = lexeme;
      this.position = position;
   }

   @Override
   public String toString()
   {
      return "<'" + lexeme + "', " + position + ">";
    // The following puts quotes around the lexeme, which works very
    // well for console output, but is doesn't work with Graphviz!
    //return "<\"" + lexeme + "\", " + position + ">";
   }
}
